##########################################################
# Image analysis to determine colocalization
# It basically estimates correlation between two channels 
# using Hfactor, pearson, overlap and Manders 
# Henry David Herce 20/7/2009
##########################################################
from Priithon.all import *
from numpy import *
#import time
#import os
import sys
import glob
#
#
def factors (fpath,neigh=20):
# fpath = "/home/labuser/henry/files/"  path to files
### create a list with the files in the directory
 fpath=fpath+"/*"
 dd = glob.glob(fpath)
 dd.sort()
###############################
### File number
 for fname in dd: 
### check if it is the c01 file and take also the c02 
  if 'c01' in fname and '.tif' in fname:
   imzr = U.loadImg(fname.replace('c01','g1'))    # chromocenter file
   imzg = U.loadImg(fname.replace('c01','g1'))  
   imznuc = U.loadImg(fname.replace('c01','nuc'))    
#  
   dim = imzr.shape   
###############################
### borders   
   borda = dim[1]-neigh
   bordb = dim[2]-neigh  
   bord = neigh    
   none = neigh+1  
###############################
### one file for each coefficient
   FILEHfac = open(fname.replace('c01','ggHfac').replace('tif','txt') , "w")
   FILEpea = open(fname.replace('c01','ggpea').replace('tif','txt') , "w")
   FILEover = open(fname.replace('c01','ggover').replace('tif','txt') , "w")   
   FILErman = open(fname.replace('c01','ggc01man').replace('tif','txt') , "w")
   FILEgman = open(fname.replace('c01','ggc02man').replace('tif','txt') , "w")  
   FILEHfac.write("File Name\tCoefficient\tZ-stack")
   FILEpea.write("File Name\tCoefficient\tZ-stack") 
   FILErman.write("File Name\tCoefficient\tZ-stack")      
   FILEgman.write("File Name\tCoefficient\tZ-stack") 
   for j in range(0,neigh):
    FILEHfac.write("\tPixDist-%s" % j)
    FILEpea.write("\tPixDist-%s" % j) 
    FILEover.write("\tPixDist-%s" % j)   
    FILErman.write("\tPixDist-%s" % j)
    FILEgman.write("\tPixDist-%s" % j)            
   for j in range(0,neigh):
    FILEHfac.write("\tPixDist-%s" % j)
    FILEpea.write("\tPixDist-%s" % j) 
    FILEover.write("\tPixDist-%s" % j)   
    FILErman.write("\tPixDist-%s" % j)
    FILEgman.write("\tPixDist-%s" % j)
   FILEHfac.write('\n')
   FILEpea.write('\n')
   FILEover.write('\n')
   FILErman.write('\n')
   FILEgman.write('\n')            
###############################
### loop over z frames
   for iim in range(0, dim[0]):
    imr = imzr[iim]
    img = imzg[iim]
    imn = imznuc[iim]
    print iim 
    Y.refresh()    
###############################
### nt summ of pixels from the nucleus, imrsum sum of intensities of all red pixels
    nt = 0
    for i in range(bord, borda):
     for j in range(bord, bordb): 
      if imn[i,j] > 0: 
          nt = nt+1   
    imrsum = 0
    imr2sum = 0   
    imgsum = 0
    img2sum = 0
    nr = 0         
    for i in range(bord, borda):
     for j in range(bord, bordb): 
      if imr[i,j] > 0:              
       imrsum = imrsum + imr[i,j]
       imr2sum = imr2sum + imr[i,j]*imr[i,j] 
       nr = nr + 1
      if img[i,j] > 0: 
       imgsum = imgsum + img[i,j]
       img2sum = img2sum + img[i,j]*img[i,j] 
###############################     
### correlation arrays
    gr = zeros((2,none),float32)
    grm = zeros((2,none),float32)
    ggm = zeros((2,none),float32)         
###############################        
# coefficients calculation
    for i in range(bord, borda):
     for j in range(bord, bordb):
      if imr[i,j] > 0 :   
### temporal correlation arrays        
       grt = zeros((2,none))
       grmt = zeros((2,none))
       ggmt = zeros((2,none))                          
       for ii in range(-(neigh), none):
        for jj in range(-(neigh), none):
         r = sqrt(ii*ii + jj*jj)                    
         if r < none:     
          if imn[i,j] > 0:  
           if imn[i+ii,j+jj] > 0:
            ig = int(r)                                          
            grt[1,ig] = grt[1,ig] + 1        
            if (imr[i,j]*img[i+ii,j+jj]) > 0: 
             grt[0,ig] = grt[0,ig] + (imr[i,j]*img[i+ii,j+jj])
             grmt[0,ig] = grmt[0,ig] + imr[i,j]
             ggmt[0,ig] = ggmt[0,ig] + img[i+ii,j+jj]
       for k in range(0, none):
        if grt[1,k] > 0:
          gr[0,k] = gr[0,k]+ grt[0,k]/grt[1,k]
          grm[0,k] = grm[0,k]+ grmt[0,k]/grt[1,k]         
          ggm[0,k] = ggm[0,k]+ ggmt[0,k]/grt[1,k]
          gr[1,k] = gr[1,k] + grt[1,k]                 
##############################      
# print correlations
    facth = (imrsum * imgsum/nt)
    factover = (sqrt(imr2sum * img2sum)) 
    factpear = (sqrt(((imrsum**2)/nt-imr2sum) * ((imgsum**2)/nt-img2sum)))
    factpear2 = (imrsum*imgsum/nt)
    FILEHfac.write(fname.split("/")[-1].split("_")[0]) 
    FILEpea.write(fname.split("/")[-1].split("_")[0])
    FILEover.write(fname.split("/")[-1].split("_")[0])
    FILErman.write(fname.split("/")[-1].split("_")[0])
    FILEgman.write(fname.split("/")[-1].split("_")[0])
    FILEHfac.write("\tH-fac\t%s" % (iim))      
    FILEpea.write("\tPearson\t%s" % (iim))      
    FILEover.write("\tOverlap\t%s" % (iim))      
    FILErman.write("\tManderR\t%s" % (iim))      
    FILEgman.write("\tManderG\t%s" % (iim))                                         
    for j in range(0,neigh):
     FILEHfac.write("\t%s" % (gr[0,j]/(facth)))
     FILEpea.write("\t%s" % ((gr[0,j]-factpear2)/(factpear)))
     FILEover.write("\t%s" % (gr[0,j]/(factover)))
     FILErman.write("\t%s" % (grm[0,j]/imrsum))
     FILEgman.write("\t%s" % (ggm[0,j]/imgsum))
    for j in range(0,neigh):
     temp = gr[1,j]/nr
     FILEHfac.write("\t%s" % temp)   # this could be useful)
     FILEpea.write("\t%s" % temp) 
     FILEover.write("\t%s" % temp)
     FILErman.write("\t%s" % temp)
     FILEgman.write("\t%s" % temp)                                 
    FILEHfac.write('\n')
    FILEpea.write('\n')
    FILEover.write('\n')
    FILErman.write('\n')
    FILEgman.write('\n')                    
    Y.refresh()
 FILEHfac.close()        
 FILEpea.close()         
 FILEover.close()         
 FILErman.close()         
 FILEgman.close()         
#
def main():    
    #fpath = '/home/labuser/Users/Corella/data/forcolocalizationanalysis'
    fpath = '/home/labuser/Users/Corella/hen/'
    coloca(fpath)


if __name__ == '__main__':
    main()