##########################################################
# Image analysis to determine colocalization
# It basically estimates correlation between two channels 
# using Hfactor, pearson, overlap and Manders 
# Henry David Herce 20/7/2009
##########################################################
from Priithon.all import *
from numpy import *
#import time
#import os
import sys
import glob
#
#
def factors (fpath,neigh=20):
# fpath = "/home/labuser/henry/files/"  path to files
### create a list with the files in the directory
 fpath=fpath+"/*"
 dd = glob.glob(fpath)
 dd.sort()
###############################
### File number
 for fname in dd: 
### check if it is the c01 file and take also the c02 
  if 'c01' in fname and '.tif' in fname:
   imzr = U.loadImg(fname.replace('c01','r1'))    # chromocenter file
   imzg = U.loadImg(fname.replace('c01','g1'))  
   imznuc = U.loadImg(fname.replace('c01','nuc'))    
#  
   dim = imzr.shape   
###############################
### borders   
   borda = dim[1]-neigh
   bordb = dim[2]-neigh  
   bord = neigh    
   none = neigh+1  
###############################
### one file for each coefficient
   FILEMax = open(fname.replace('c01','Max').replace('tif','txt') , "w") 
   FILEMax.write("File Name\tZ-stack\tHfact\tPearsons\tOverlap\tMandersR\tMandersG\n")             
###############################
### loop over z frames
   for iim in range(0, dim[0]):
    imr = imzr[iim]
    img = imzg[iim]
    imn = imznuc[iim]                            
###############################
### nt sum of pixels from the nucleus, imrsum sum of intensities of all red pixels   
### I also create image arrays and sort them 
    dima = dim[1]*dim[2]
    iarr = zeros(dima,float32)
    iagg = zeros(dima,float32)
    nt = 0
    k=0    
    for i in range(bord, borda):
     for j in range(bord, bordb):   
      if imn[i,j] > 0: 
       nt = nt+1
       iarr[k]=imr[i,j]   
       iagg[k]=img[i,j]
      k=k+1           
    iarr.sort()
    iagg.sort()                 
    imrsum = 0
    imr2sum = 0   
    imgsum = 0
    img2sum = 0
    nr = 0         
    for i in range(bord, borda):
     for j in range(bord, bordb): 
      if imr[i,j] > 0:              
       imrsum = imrsum + imr[i,j]
       imr2sum = imr2sum + imr[i,j]*imr[i,j] 
       nr = nr + 1
      if img[i,j] > 0: 
       imgsum = imgsum + img[i,j]
       img2sum = img2sum + img[i,j]*img[i,j] 
###############################     
### correlation arrays, in this case is just one number
    gr = 0
    grm = 0
    ggm = 0         
###############################        
# coefficients calculation
    for i in range(0, dima):
      if (iarr[i]*iagg[i]) > 0 :   
### temporal correlation arrays        
#       grt = 0
#       grmt = 0
#       ggmt = 0                          
#       for ii in range(-(neigh), none):
#        for jj in range(-(neigh), none):
#         r = sqrt(ii*ii + jj*jj)                    
#         if r < none:     
#          if imn[i,j] > 0:  
#           if imn[i+ii,j+jj] > 0:
#            ig = int(r)                                          
#            grt[1,ig] = grt[1,ig] + 1        
#       if (iarr[i]*iagg[i]) > 0: 
#       grt = grt + (iarr[i]*iagg[i])
#       grmt = grmt + iarr[i]
#       ggmt = ggmt + iagg[i]
# I could remove some extra variables but I left them to make easy to track any potential problems        
       gr = gr+ (iarr[i]*iagg[i])
       grm = grm+ iarr[i]      
       ggm = ggm+ iagg[i]                 
##############################      
# print correlations
    facth = (imrsum * imgsum/nt)
    factover = (sqrt(imr2sum * img2sum)) 
    factpear = (sqrt(((imrsum**2)/nt-imr2sum) * ((imgsum**2)/nt-img2sum)))
    factpear2 = (imrsum*imgsum/nt)              
#    for j in range(0,neigh):
    FILEMax.write(fname.split("/")[-1].split("_")[0])
    FILEMax.write("\t%s" % (iim))    
    FILEMax.write("\t%s" % (gr/(facth)))       
    FILEMax.write("\t%s" % ((gr-factpear2)/(factpear)))    
    FILEMax.write("\t%s" % (gr/(factover)))     
    FILEMax.write("\t%s" % (grm/imrsum))    
    FILEMax.write("\t%s" % (ggm/imgsum))                            
    FILEMax.write('\n')                    
    Y.refresh()
   FILEMax.close()               
#
def main():    
    #fpath = '/home/labuser/Users/Corella/data/forcolocalizationanalysis'
    fpath = '/home/labuser/Users/Corella/hen/test_max'
    coloca(fpath)


if __name__ == '__main__':
    main()



                      
            
                      

