##########################################################
# Image analysis to extract the nucleus  
# Henry David Herce 15/10/2009
##########################################################
from Priithon.all import *
from numpy import *
#import time
#import os
import sys
#
def filter_hen(fpath,bord=25,neigh=20):
# fpath = "/home/labuser/henry/files/"  path to files
### create a list with the files in the directory
 fpath=fpath+"/*"
 import glob
 dd = glob.glob(fpath)
 dd.sort() 
############################### 
# bord = 25  a number of pixels in the border that dont contain information to dont go over the array limit
# neigh = 20  nbumber of pixels to look for local intensity average
 none = neigh+1
 mfilt = 1.200000000 # leave only pixels with an intensity higher than 1.2 the local average
###############################
### File number
 for fname in dd: 
### check if it is the c01 file and take also the c02 
  if 'c01' in fname and '.tif' in fname:
   imzr = U.loadImg(fname)    # chromocenter file
   imzg = U.loadImg(fname.replace('c01','c02'))  
   imznuc = U.loadImg(fname.replace('c01','nuc'))    
#   
   dim = imzr.shape   
###############################
# output images
   imtr = zeros((dim[0],dim[1],dim[2]))  
   imtg = zeros((dim[0],dim[1],dim[2]))
###############################
### average black intensity
   imr = imzr[0]
   first = imr[:50, :50]         
   black = (first.sum()/(50*50))*1.0
##
###############################
### loop over z frames
   for iim in range(0, dim[0]):
    imr = imzr[iim]
    img = imzg[iim]
###############################
# if average intensity is 1.0 higher than black intensity compute the image
    ave = imr.sum() / (dim[1]*dim[2])    
    if ave > black:    
###############################
### neighbourhood mean (the amount of pixels has to be chosen according to the image size)   
     imeanr = zeros((dim[1],dim[2]))
     imeang = zeros((dim[1],dim[2]))     # this could be the sintaxis but I will try the easy form first
###############################
# I make zero the pixels outside of the nucleus, given by the mask
     for i in range(0, dim[1]):
      for j in range(0, dim[2]): 
        if imznuc[iim][i,j]<1:
         imr[i,j]=0
         img[i,j]=0  
###############################
     for i in range(0, dim[1]):
      for j in range(0, dim[2]):  
       if imznuc[iim][i,j]>0:
        nt=0     
        for ii in range(-(neigh), none):
         for jj in range(-(neigh), none):
          iii=i+ii
          jjj=j+jj
          if i+ii > (dim[1]-1):   #to don't go over the array limit (there is any better way in python?)   
           iii=iii-dim[1]
          if j+jj > (dim[2]-1):
           jjj=jjj-dim[2]
          if imznuc[iim][iii,jjj]>0:       
           imeanr[i,j] = imeanr[i,j] + imr[iii,jjj]
           imeang[i,j] = imeang[i,j] + img[iii,jjj]
           nt=nt+1   
        imeanr[i,j] = (imeanr[i,j]) * mfilt/nt
        imeang[i,j] = (imeang[i,j]) * mfilt/(nt*1.2)                                    
###############################
### Matrix with those pixels with intensity bigger than mfilt the black average and with at least 3 neighbors 
     imr2 = zeros((dim[1],dim[2]))
     imr2one = zeros((dim[1],dim[2]))
     img2 = zeros((dim[1],dim[2]))
     img2one = zeros((dim[1],dim[2]))
     borda = dim[1]-bord + 1
     bordb = dim[2]-bord + 1
     for i in range(1,dim[1]-1):
      for j in range(1,dim[2]-1):
       if imznuc[iim][i,j]>0:          
        if imr[i,j] > imeanr[i,j]:
         ne=0
# here I fiter isolated points that are over the average, the points must have at least 1 neighbour          
# this filter is not always a good idea, but for chromocenters it usually is
# I don't apply it to the replication focites
         for ii in range(-1, 2):
          for jj in range(-1, 2):
           if imr[i+ii,j+jj] > imeanr[i+ii,j+jj]: 
            ne=ne+1    
         if ne > 1:                           
          imr2[i,j] = imr[i,j]
          imr2one[i,j] = 1
        if img[i,j] > imeang[i,j]:          
         img2[i,j] = img[i,j]
         img2one[i,j] = 1          
###############################   
### take now red pixels that are over the average intensity of red pixels
# I think that I don't need this step
#     ave = 0
#     nr = 0
#     for i in range(bord, borda):
#      for j in range(bord, bordb):
#       nr = nr + imr2one[i,j] 
#       ave = ave + imr2[i,j]
#     ave = ave / nr    
#     nr = 0
#     imr2sum = 0
#     for i in range(0, dim[1]):
#      for j in range(0, dim[2]):
#       if (imr2[i,j] < ave):
#        imr2[i,j] = 0.00
#        imr2one[i,j] = 0
    imtr[iim]=imr2
    imtg[iim]=img2      
   U.saveImg(U.asFloat32(imtr),fname.replace('c01','r1'),forceMultipage=1)
   U.saveImg(U.asFloat32(imtg),fname.replace('c01','g1'),forceMultipage=1)             

def main():    
    #fpath = '/home/labuser/Users/Corella/data/forcolocalizationanalysis'
    fpath = '/home/labuser/Users/Corella/hen/'
    coloca(fpath)


if __name__ == '__main__':
    main()            
        
        
